<template>
  <div :class="`alert alert-${colorClass}`">
    <h4 class="alert-heading"><i :class="icon"></i>{{ title }}</h4>
    <p>
      Task ID: <code>{{ task.task_id }}</code
      ><br />
      Started: {{ started }}<br />
      Finished: {{ finished }}<br />
      <span v-if="status.toLowerCase() == 'pending'"
        >Duration: {{ duration }}</span
      >
    </p>
  </div>
</template>

<script>
const alertConfig = {
  failure: { class: "danger", icon: "fas fa-exclamation-triangle" },
  success: { class: "success", icon: "fas fa-check-circle" },
  pending: { class: "warning pending", icon: "fas fa-spinner" },
  default: { class: "warning pending", icon: "fas fa-spinner" },
};

export default {
  name: "TaskInfo",
  props: {
    status: { type: String, default: "PENDING" },
    task: { type: Object, default: () => {} },
  },
  computed: {
    icon() {
      if (
        Object.prototype.hasOwnProperty.call(
          alertConfig,
          this.status.toLowerCase()
        )
      ) {
        return alertConfig[this.status.toLowerCase()].icon;
      }
      return alertConfig.default.icon;
    },
    colorClass() {
      if (
        Object.prototype.hasOwnProperty.call(
          alertConfig,
          this.status.toLowerCase()
        )
      ) {
        return alertConfig[this.status.toLowerCase()].class;
      }
      return alertConfig.default.class;
    },
    title() {
      return this.task.name.replaceAll("_", " ");
    },
    started() {
      if (this.task.date_start === null) return "-";
      return new Date(this.task.date_start).toLocaleString();
    },
    finished() {
      if (this.task.date_done === null) return "-";
      return new Date(this.task.date_done).toLocaleString();
    },
    duration() {
      if (this.task.date_start === null) return "-";
      const duration =
        (new Date().getTime() - new Date(this.task.date_start).getTime()) /
        1000;
      return (
        Math.floor(duration / 60) + " min, " + Math.round(duration % 60) + " s"
      );
    },
  },
};
</script>

<style lang="scss">
h4.alert-heading {
  text-transform: capitalize;
}
.alert.pending {
  h4.alert-heading i {
    display: inline-block;
    animation: rotate-cog 1000ms ease-in-out infinite;
  }
}
div.task-list div.alert {
  line-height: 1.5;
}
</style>
